#include "wordz.h"

void DrawRect(int x, int y, int w, int h, Uint32 outer, Uint32 inner)
{
	float xx = ((float)x / (float)SCREEN_WIDTH) * ratio - half_ratio;
	float yy = 0.5f - ((float)y / (float)SCREEN_HEIGHT);
	float xx2 = (float)w / (float)SCREEN_WIDTH * ratio;
	float yy2 = (float)h / (float)SCREEN_HEIGHT;
	float bw = 5.0f / (float)SCREEN_WIDTH * ratio;

	Uint8 outer_r;
	Uint8 outer_g;
	Uint8 outer_b;
	Uint8 inner_r;
	Uint8 inner_g;
	Uint8 inner_b;

	SDL_GetRGB(outer, screen->format, &outer_r, &outer_g, &outer_b);
	SDL_GetRGB(inner, screen->format, &inner_r, &inner_g, &inner_b);
	
	glLoadIdentity();
	glTranslatef(xx, yy, -2.2f);

	glBegin(GL_QUADS);
		glColor3f((float)outer_r/255.0f, (float)outer_g/255.0f,
				(float)outer_b/255.0f);
		glVertex3f(0.0f, -yy2, 1.0f);
		glColor3f((float)outer_r/255.0f, (float)outer_g/255.0f,
				(float)outer_b/255.0f);
		glVertex3f(xx2, -yy2, 1.0f);
		glColor3f((float)outer_r/255.0f, (float)outer_g/255.0f,
				(float)outer_b/255.0f);
		glVertex3f(xx2, 0.0f, 1.0f);
		glColor3f((float)outer_r/255.0f, (float)outer_g/255.0f,
				(float)outer_b/255.0f);
		glVertex3f(0.0f, 0.0f, 1.0f);
		// inside
		glColor3f((float)inner_r/255.0f, (float)inner_g/255.0f,
				(float)inner_b/255.0f);
		glVertex3f(0.0f+bw, -yy2+bw, 1.0f);
		glColor3f((float)inner_r/255.0f, (float)inner_g/255.0f,
				(float)inner_b/255.0f);
		glVertex3f(xx2-bw, -yy2+bw, 1.0f);
		glColor3f((float)inner_r/255.0f, (float)inner_g/255.0f,
				(float)inner_b/255.0f);
		glVertex3f(xx2-bw, 0.0f-bw, 1.0f);
		glColor3f((float)inner_r/255.0f, (float)inner_g/255.0f,
				(float)inner_b/255.0f);
		glVertex3f(0.0f+bw, 0.0f-bw, 1.0f);
	glEnd();
}

void SetIcon(void)
{
#ifdef __linux__
	char icon_name[1000];
	snprintf(icon_name, 999, "%s/icon.bmp", Datapath());
	SDL_Surface* icon = SDL_LoadBMP(icon_name);
	SDL_WM_SetIcon(icon, 0);
#endif
}
