#ifndef _WORDZ_H
#define _WORDZ_H

#include <new>
#include <vector>
#include <string>
#include <SDL/SDL.h>
#include <GL/gl.h>
#include <GL/glext.h>

#ifndef __linux__
#include <windows.h>
#endif

const int SCREEN_WIDTH = 800;
const int SCREEN_HEIGHT = 600;
const int SCREEN_BPP = 16;

const int NUM_SKIPS = 10;

const int FONT_W = 24;
const int FONT_H = 40;
const int NUM_FONT_CHARS = 94;
extern const char* FONT_CHARS;

// Number of textures besides the font glyphs
const int NUM_ADDITIONAL_TEXTURES = 0;

const int NUM_TEXTURES = NUM_FONT_CHARS+NUM_ADDITIONAL_TEXTURES;

struct Configuration {
	int bpp;
	bool has_hw_surfaces;
};

extern SDL_Surface* screen;
extern GLuint textures[NUM_TEXTURES];
extern float ratio;
extern float half_ratio;
extern float char_w;
extern float char_h;
extern float printed_char_w;
extern Configuration cfg;
extern int char_padding_h; // the amount of blank space to the left of characters
extern int char_padding_v; // the amount of blank space above the character

extern char* Datapath(void);
extern SDL_Surface** LoadFont(char* filename, int char_w, int char_h)
	throw (std::bad_alloc);
extern void DeleteFont(SDL_Surface** font);
extern void GLPrintf(int x, int y, char* format, ...);
extern void DrawRect(int x, int y, int w, int h, Uint32 outer, Uint32 inner);
extern void SetIcon(void);
extern void ReadDictionary(void) throw (std::bad_alloc);
extern std::vector<std::string> dictionary;

#endif // WORDZ_H
